SAL_ArcHandler = {};

local arcPics = {};

function SAL_ArcHandler.ClearArcPics()
	for i,v in ipairs(arcPics) do
		arcPics[i].active = false;
		arcPics[i]:Hide();
	end
end

function SAL_ArcHandler.GetNewArcPic()
	for i,v in ipairs(arcPics) do
		if not arcPics[i].active then
			arcPics[i].active = true;
			return arcPics[i];
		end
	end

	local pix = SalFrame:CreateTexture(nil, "OVERLAY");
	pix.active = true;

	arcPics[#arcPics + 1] = pix;
	return pix;
end

local function rotatePoint(x, y, ox, oy, sina, cosa)
	local _x = x - ox;
	local _y = y - oy;
	
	local __x = _x * cosa - _y * sina;
	local __y = _y * cosa + _x * sina;
	
	return __x + ox, __y + oy;
end

local function rotateTexture(t, angle)
	local tl = {x=0, y=0};
	local bl = {x=0, y=1};
	local tr = {x=1, y=0};
	local br = {x=1, y=1};
	local o = {x=.5, y=.5};
	
	local sina = sin(-angle);
	local cosa = cos(-angle);
	
	local tlx, tly = rotatePoint(tl.x, tl.y, o.x, o.y, sina, cosa);
	local blx, bly = rotatePoint(bl.x, bl.y, o.x, o.y, sina, cosa);
	local trx, try = rotatePoint(tr.x, tr.y, o.x, o.y, sina, cosa);
	local brx, bry = rotatePoint(br.x, br.y, o.x, o.y, sina, cosa);
	
	t:SetTexCoord(
		tlx, tly,
		blx, bly,
		trx, try,
		brx, bry
	);
end

function SAL_ArcHandler.GetArcPic(t)
	local txt = SAL_ArcHandler.GetNewArcPic();

	local s = SAL_Options.drawScale * 512;
	txt:SetAlpha(0.3);
	if (t.color == "red") then
		txt:SetTexture("Interface\\AddOns\\Sal\\Artwork\\arc1024_red");
	elseif (t.color == "yellow") then
		txt:SetTexture("Interface\\AddOns\\Sal\\Artwork\\arc1024_yellow");
		s = s / 2;
	elseif (t.color == "green") then
		txt:SetTexture("Interface\\AddOns\\Sal\\Artwork\\arc1024_green");
		s = s / 4;
	else
		txt:SetTexture("Interface\\AddOns\\Sal\\Artwork\\arc1024");
	end
	txt:ClearAllPoints();
	txt:SetWidth(s);
	txt:SetHeight(s);
	rotateTexture(txt, t.v - 90);
	txt:Show();
	
	return txt;
end

