SAL_OptionManager = {};

function SAL_OptionManager.GetDefault()
	local o = {};
	
	o.AutoClear = true;
	o.AutoShow = true;
	o.CombatHide = false;
	o.Sounds = true;
	o.ShowBorders = true;
	o.ShowArc = true;
	o.ShowFragments = true;
	o.TrackFragments = true;
	o.ArcOpac = 0.2;
	--o.UseGm2 = true;
	o.drawScale = 5;
	
	return o;
end

local function ReadCB(e)
	if (e:GetChecked() == nil) then
		return false;
	else
		return true;
	end	
end

local function clone(t)
	local new = {}
	local i, v = next(t, nil)
	while i do
		new[i] = v
		i, v = next(t, i)
	end
	return new
end

function SAL_OptionManager.Read()
	local o = clone(SAL_Options);

	o.AutoClear = ReadCB(SalFrameOptions_AutoClear_Check);
	o.AutoShow = ReadCB(SalFrameOptions_AutoShow_Check);
	o.CombatHide = ReadCB(SalFrameOptions_CombatHide_Check);
	o.Sounds = ReadCB(SalFrameOptions_Sounds_Check);
	o.ShowBorders = ReadCB(SalFrameOptions_ShowBorders_Check);
	o.ShowArc = ReadCB(SalFrameOptions_ShowArcs_Check);
	o.ShowFragments = ReadCB(SalFrameOptions_ShowFragment_Check);
	o.TrackFragments = ReadCB(SalFrameOptions_TrackFragment_Check);
	o.ArcOpac = SalFrameOptions_ArcOpac_Slide:GetValue();
	
	return o;
end

function SAL_OptionManager.Set(o)

	SalFrameOptions_AutoClear_Check:SetChecked(o.AutoClear);
	SalFrameOptions_AutoShow_Check:SetChecked(o.AutoShow);
	SalFrameOptions_CombatHide_Check:SetChecked(o.CombatHide);
	SalFrameOptions_Sounds_Check:SetChecked(o.Sounds);
	SalFrameOptions_ShowBorders_Check:SetChecked(o.ShowBorders);
	SalFrameOptions_ShowArcs_Check:SetChecked(o.ShowArc);
	SalFrameOptions_ShowFragment_Check:SetChecked(o.ShowFragments);
	SalFrameOptions_TrackFragment_Check:SetChecked(o.TrackFragments);
	SalFrameOptions_ArcOpac_Slide:SetValue(o.ArcOpac);
end

function SAL_OptionManager.Patch(o)
	if (o == nil) then
		o = {};
	end
	local o2 = SAL_OptionManager.GetDefault();

	if (o.AutoClear ~= nil) then o2.AutoClear = o.AutoClear; end
	if (o.AutoShow ~= nil) then o2.AutoShow = o.AutoShow; end
	if (o.CombatHide ~= nil) then o2.CombatHide = o.CombatHide; end
	if (o.Sounds ~= nil) then o2.Sounds = o.Sounds; end
	if (o.ShowBorders ~= nil) then o2.ShowBorders = o.ShowBorders; end
	if (o.ShowArc ~= nil) then o2.ShowArc = o.ShowArc; end
	if (o.ShowFragments ~= nil) then o2.ShowFragments = o.ShowFragments; end
	if (o.TrackFragments ~= nil) then o2.TrackFragments = o.TrackFragments; end
	if (o.ArcOpac ~= nil) then o2.ArcOpac = o.ArcOpac; end
	--if (o.UseGm2 ~= nil) then o2.UseGm2 = o.UseGm2; end
	if (o.drawScale ~= nil) then o2.drawScale = o.drawScale; end
	
	return o2;
end
